
REM prevod INP/OUT souboru z VKSACHu do fontu 1ECHECS

REM Lze primo prohlizet pomoci IE4
REM nebo importovat do WORDu 97


REM ----------------------------------------------------
REM Chyby k oprave:
REM !!! pokud je vyzva prazdna, tak se neulozil v pripade W<>0 cely radek s textem 3

REM !!! pravy okraj diagramu nekdy neni pri tisku zcela rovny. Proc? Vadi slozene kameny DE apod.?
REM ----------------------------------------------------

rem v4.5 18.3.2003
rem opravena chyba, kdyz vsechny ulohy v jedne radce nebyly C+ (vsechny {-})
rem tak se nevygenerovala radka se 4.textem

rem v4.4 10.9.1999
rem pri parametru R=1S (apod.) se dalsi radky generuji bez stylu H5 (jako normal)
rem (je nutne, protoze jinak WORD spatne importuje <B>)

rem v4.3 30.8.1999
rem prevody vyrazu typu bKe4, Ke4 pri prevodu na fonty na prislusnou barvu
rem oprava barvy v prevodu na fonty u nekterych komplikovanych zapisu #2 (barva se spatne
rem  prevadela, pokud mezi tahy oddelenymi carkou byl prvni pesec)

rem v4.2 25.8.1999
rem opravena chyba s @(IC2), kdy se parametry v zavorce braly zde jako circe

rem v4.1 23.8.1999
rem upravy ve formatu velikosti 6 pro 2 sloupce do Wordu (zvetsen prostor pro text3 a 4)
rem zvesten rozmer tabulky kdyz sachovnice 9x9 nebo 10x10

REM v4.0 16.8.1999
REM unifikace kodu a grafiky exokamenu (v reseni mozne i dvojznakove nazvy)

REM Opraveny tyto chyby
REM   prevod fontu v reseni nechodil spravne pro T=2 nebo T=3
REM   pri prevodu mezi notacemi se ztracel znak exokrale (TCK jen na NH a ne NHK)
REM     a tez znak n pred neutralnimi kameny
REM neprevadely se do fontu (a tedy i mezi notacemi) dvojznakove promeny na exokameny


REM v3.4 10.8.1999
REM prevod kamenu s funkci krale v reseni zmenen (v textu je rozliseni krizkem nedostatecne)
REM predsazen znak k pred
REM dale opravena chyba, kdy se pri prevodu ztraci z CK nebo VK znak K (ale neprevede se na font)

REM prevod na fonty nekdy vadi, pokud nasleduje komentar v cizim jazyku apod.
REM zavedena moznost prevodu na font jen v 1.radce reseni, pomoci R=1S apod.

REM comment umisten do tabulky (pokud W=4 E=3)


REM v3.3 9.8.1999
REM rozsireni parametru C
REM moznost automatickeho cislovani pozic - pokud W=4 a N=8, styl <PRE> s cislovanim
REM  cislovani je zavedeno az ve WORDu pomoci stylu PRE (sablonou)

REM moznost ulozeni pozic a reseni jako komentar (aby bylo zachovano ve WORDu s moznosti exportu)
REM E=0 bez komentare
REM E=1 pozice do komentare
REM E=2 pozice i reseni do komentare
REM E=3 jako E=2 ale COMMENT vlozen az do tabulky (kvuli lepsimu presouvani ve WORDu)

REM v3.1 19.7.1999
REM opravena chyba s nulovanim VKPAR$ (kdyz v radku vyzvy nebylo lomitko)

REM v3.0 17.7.1999
REM prevody mezi notacemi (pro reseni)

REM v2.9 17.7.1999
REM umozneno pouziti HTML tagu v OUT souboru (napr. <B> text </B> apod.)

REM v2.8 26.6.1999
REM znaky < a > nahrazeny sipkami z fontu SYMBOL
REM opraveno spravne precteni cislovani (pokud neni text3)
REM u uloh bez bileho krale po napr. XD3D3 je kral cerny (opraveno)


REM namety k doreseni

REM !! zmenseni okraju nad a pod diagramy (tomu lze castecne pomoct ve WORDu nastavenim radkovani)
REM vyreseno parametrem 5X, vyzaduje ovsem upraveny font 2ECHECS.TTF (pouze rozsireny znaky s
REM kody 69 a 240)

REM pro D=1 reseni tez vedle diagramu jako TABLE (jako parametr D=0)

REM prekroceni rozsahu stringu pri velmi dlouhem reseni (uloha 972 ve VKULOHY)
REM notace v textu - jak poznat cerne kameny a jak odlisit od 1. -


REM v INPTIFu bylo i spojovani 2 diagramu do 1 (mozna lze udelat i rucne)


REM dalsi fonty
REM <FONT FACE="Cheq" SIZE=5><P>kKkK</B>kKkK</P>
REM             KDVSJP  srafovane
REM bile        kdtlsb  KDTLSB
REM cerne       bold    bold
REM prazdne     mezera  x
REM okraje nejsou
REM
REM
REM <FONT FACE="DiagramTTHabsburg" SIZE=5>
REM             KDVSJP  srafovane
REM bile        KQRLNP  mKwQtRvLsNzP
REM cerne       kqrlnp  mkwqtrvlsnzp
REM prazdne     -       +
REM
REM okraje priklad
REM XIIIIIIIIY<BR>
REM 9-+-+-+-mK0<BR>
REM 9+-zp-trrzPP0<BR>
REM 9-zpP+-+-mk0<BR>
REM 9+p+-zp-zp-0<BR>
REM 9-zP-+P+p+0<BR>
REM 9+-+-+-zP-0<BR>
REM 9-+-+-+-+0<BR>
REM 9+-+-+-+-0<BR>
REM xiiiiiiiiy<BR>
REM


	DEFINT A-Z
	ver$ = "4.5"

	g$ = COMMAND$
	IF g$ <> "" THEN 100
50      PRINT "            INPFONT v" + ver$ + " (c) V.Kotesovec 1999"
	PRINT
	PRINT "prevod INP/OUT souboru z VKSACHu do fontu 1ECHECS (Ch.Poisson)"
	PRINT
	PRINT "vyhody: Cely soubor je text, nemusi se vkladat grafika. HTM lze nacist do"
	PRINT " WORDu 97, bloky textu obsahujici diagramy jdou libovolne presouvat."
	PRINT " Vse jsou TTF - lze bez ztraty kvality zmensovat. Nevadi tolik texty mimo"
	PRINT " rozsah, text lze editovat. Grafika exokamenu je kompatibilni s VKSACHem"
	PRINT " Lze tisknout na libovolne tiskarne"
	PRINT
	PRINT "nevyhody: HTM je zobrazitelny jen pod IE4 (nejde Netscape), obcas je nutny"
	PRINT " rezim 1024x768 bodu. Zobrazeni pod IE4 a ve WORDu97 neni 100% kompatibilni"
	PRINT
	PRINT "Spusteni programu:"
	PRINT
	PRINT "INPFONT file1.inp file2.htm F=5 D=1 O=S C=1 N=0 V=42322323 W=0 R=0 T=1"
	PRINT "           parametry neni nutno uvadet - uvedeny preddefinovane hodnoty"
	GOSUB 80
	PRINT "INPFONT file1.inp file2.htm F=5 D=1 O=S C=1 N=0 V=42322323 W=0 R=0 T=1 E=0"
	PRINT
	PRINT " F=1 az 7  velikost sachovych fontu (1=9,2=10,3=12,4=14,5=18,6=24,7=36)"
	PRINT "           X za cislem = zuzeni mezer nad a pod diagramem"
	PRINT "           napr. F=5X (je treba mit upraveny 2ECHECS.TTF, lisi se od fontu"
	PRINT "           1ECHECS pouze u znaku s kody 69 a 240)"
	PRINT " T=1 az 3  typ fontu (1 az 3, pouze pro T=1 jsou exokameny)"
	PRINT " D=1 az 6  pocet diagramu vedle sebe"
	PRINT " O=S       nebo O=D  sirka okraje diagramu (pri W=4 je mozne pouze S)"
	PRINT " C=0 az 3  1= prevod cestiny (z VKSACHove do WINDOWS), 2 = bez prevodu"
	PRINT "           3= prevod pouze v radku vyzvy, 0 = odstraneni VKSACHove diakritiky"
	PRINT " N=0,2,4  cislovani (z INPINP) v radku 2 nebo 4, 0=bez cislovani, 9(8)=zavest"
	PRINT "          (pokud je cislo zakonceno znakem S, doplni se i pred radky reseni)"
	PRINT " V=1 az 7  velikost textovych fontu, poradi radky 1, 2 (nad diagramem) "
	PRINT "           radka 3 (vyzva,text,pocet kamenu), radka 4 (C+,text,cislo ulohy)"
	PRINT "           (pri pouziti stylu (W=4) nema parametr V vyznam)"
	PRINT " W=0 az 4  1= HTM k prevodu na DOC pro WORD97 (s vyuzitim tabulek)"
	PRINT "           2= 1 a sirky v % (spec.pro  D=3 F=5 strana A4, D=3 F=3 strana A5)"
	PRINT "           4= je jako W=2 s pouzitim stylu H1 az H6 a sablon ve WORDu"
	PRINT "              doporuceno pro publikace (obvykle s D=3 a F=5)"
	PRINT "           0= pro IE4,5 (pokud je cilem HTM), ale lze pouzit i pro WORD97"
	PRINT " R=0 az 8  1= prevod kodu kamenu v reseni na fonty, 0 = klasicka notace"
	GOSUB 80
	PRINT "Pri volbe W=0 je vystupni soubor urcen pro prohlizeni Internet explorerem "
	PRINT " verze >=4"
	PRINT
	PRINT "Pri volbe W=1 nebo W=2 se soubor HTM nacte do WORDu 97"
	PRINT " (v menu Otevrit soubor - muze trvat i nekolik minut)"
	PRINT " (pro 200 diagramu trva cca 2 minuty/300MHz, pro 1000 diagramu 20 minut)"
	PRINT " Pak se ulozi jako dokument WORDu a dale se pracuje se souborem DOC"
	PRINT " (doba nacitani souboru DOC je uz bleskova i pro 1000 diagramu)"
	PRINT " Dobre je v menu Odstavec zmensit mezery mezi odstavci na 0"
	PRINT " a radkovani nastavit jako jednoduche."
	PRINT
	PRINT "Pri volbe W=4 se nejprve nacte prazdna sablona obsahujici formaty stylu"
	PRINT " (v menu Soubor Novy) a nyni se v menu Vlozit Soubor vlozi soubor HTM"
	PRINT " V sablone SACHDIAG.DOT je zajisteno napr. radkovani, svazani radek"
	PRINT " diagramu na 1 stranku, prepinani kontroly pravopisu atd."
	PRINT " Lze vytvaret vlastni sablony a format je tak zcela v rukou uzivatele."
	GOSUB 80
	PRINT "Poznamky:"
	PRINT "Cislovani odstavcu reseni je nejlepsi zavest az ve WORDu"
	PRINT "Potlaceni vypisu C+, lze zvolit napr. V=42322023"
	PRINT "Pokud jsou sachovnice jine nez 8x8 a W=0, je treba volit jen D=1"
	PRINT "Zobrazit jde sachovnice az do rozmeru 10x10"
	PRINT "Parametr D=0 (pri W=4) funguje jako D=1 s umistenim textu vedle diagramu"
	PRINT
	PRINT "Rozsireni parametru R pro prevod reseni v ruznych notacich"
	PRINT "R=2 jako R=1 s resenim v nemecke notaci"
	PRINT "R=3 jako R=0 prevod z ceske do nemecke"
	PRINT "R=4 jako R=0 prevod z ceske do anglicke"
	PRINT "R=5 jako R=0 prevod z ceske do francouzske"
	PRINT "R=6 jako R=0 prevod z nemecke do ceske"
	PRINT "R=7 jako R=0 prevod z anglicke do ceske"
	PRINT "R=8 jako R=0 prevod z francouzske do ceske"
	PRINT "Pokud nasleduje znak S (napr. R=1S), je preveden jen 1.radek reseni"
	PRINT
	PRINT "E=0 bez komentare"
	PRINT "E=1 pozice do komentare"
	PRINT "E=2 pozice i reseni do komentare"
	GOSUB 80
	PRINT "Priklady:"
	PRINT "INPFONT.EXE ulohy.inp ulohy.htm w=4 d=3 f=5x n=9"
	PRINT " Prevod souboru ULOHY.INP na soubor ULOHY.HTM urceny pro WORD97"
	PRINT " s vyuzitim sablon. Tri diagramy vedle sebe. Velikost fontu 5 s mensimi"
	PRINT " okraji nad a pod diagramem. Diagramy budou automaticky ocislovany."
	PRINT
	PRINT "INPFONT.EXE ulohy.out ulohy.htm w=4 d=3 f=5x r=1"
	PRINT " Prevod souboru ULOHY.OUT na soubor ULOHY.HTM"
	PRINT " Proti predchozimu prikladu nebudou diagramy cislovany (cislovani lze"
	PRINT " pripravit i predem starym zpusobem programem INPINP)."
	PRINT " Notace reseni bude prevedena na diagramove fonty."
	PRINT
	PRINT "INPFONT.EXE ulohy.inp ulohy.htm"
	PRINT " Prevod souboru ULOHY.INP na soubor ULOHY.HTM urceny pro Internet explorer"
	PRINT " (verze >=4). Vyuzivaji se preddefinovane hodnoty (spec. w=0 d=1 f=5)"
	PRINT " Pouze 1 diagram vedle sebe se standartni velikosti kamenu i pisem."
	PRINT
	GOTO 9100

80      PRINT
	PRINT "<enter> dalsi strana helpu ";
	INPUT a$
	CLS
	PRINT
	RETURN


REM W=2 je jako W=1 ale s % delek v tabulkach
REM W=3 je jako W=1 ale bez atributu center u diagramu (jinak se spatne zobrazuje v IE4)
REM     (tez je rozsireno pole, vyznam je ale jen diagnosticky)
REM W=4 je jako W=2 s pouzitim stylu H1 az H6
REM kdyz je text1 prazdny, lze zvolit V=42322323 a radka se negeneruje
REM pokud nechceme vypisovat C+, lze zvolit napr. V=42322023
REM F=5X znamena pouziti upraveneho fontu 2ECHECS.TTF, ktery se lisi jen tim, ze horni a dolni
REM     okraj je soucasti pole (a odpadaji tak nechtene mezery nad a pod diagramem)


100     k = INSTR(g$, " ")
	IF k = 0 THEN 50
	xfile$ = MID$(g$, 1, k - 1)
	OPEN xfile$ FOR INPUT AS #2
	PRINT "Vstupni soubor:  "; xfile$
	g$ = MID$(g$, k + 1)
	k = INSTR(g$, " ")
	xfile$ = g$
	par$ = ""
	IF k = 0 THEN 150
	xfile$ = MID$(g$, 1, k - 1)
	par$ = UCASE$(MID$(g$, k + 1))
150     IF xfile$ = "" THEN 50
	OPEN xfile$ FOR OUTPUT AS #4
	PRINT "Vystupni soubor: "; xfile$

	
	pocdia = 1       ' pocet diagramu vedle sebe
	elimcz = 1       ' 0=eliminace diakritiky
	cad$ = "S"       ' okraj diagramu
	parf = 5         ' velikost fontu
	parr = 0
	word97 = 0
	numb = 0
	numsol = 0
	xokraj = 0
	yokraj = 0
	fvel$ = "42322323"
	redukr = 1      ' vylouceni prazdnych radku tabulky (default)
	solfon = 0

	fonnum = 1
	foname$ = CHR$(34) + "1Echecs" + CHR$(34)

	coment = 0      ' =1 notace pozic se ulozi jako komentar

	k = INSTR(par$, "D=")
	IF k <> 0 THEN pocdia = VAL(MID$(par$, k + 2, 1))
	k = INSTR(par$, "O=")
	IF k <> 0 THEN cad$ = MID$(par$, k + 2, 1)
	k = INSTR(par$, "C=")
	IF k <> 0 THEN elimcz = VAL(MID$(par$, k + 2, 1))
	k = INSTR(par$, "E=")
	IF k <> 0 THEN coment = VAL(MID$(par$, k + 2, 1))
	k = INSTR(par$, "R=")
	IF k = 0 THEN 155
	solfon = VAL(MID$(par$, k + 2, 1))
	IF MID$(par$, k + 3, 1) = "S" THEN parr = 1
155     k = INSTR(par$, "T=")
	IF k <> 0 THEN fonnum = VAL(MID$(par$, k + 2, 1))
	k = INSTR(par$, "N=")
	IF k = 0 THEN 160
	numb = VAL(MID$(par$, k + 2, 1))
	IF MID$(par$, k + 3, 1) = "S" THEN numsol = 1
160     k = INSTR(par$, "V=")
	IF k <> 0 THEN fvel$ = MID$(par$, k + 2, 8)
	IF LEN(fvel$) = 1 THEN fvel$ = fvel$ + "2322323"
	IF MID$(fvel$, 1, 2) = "0 " THEN fvel$ = "02322323"

	k = INSTR(par$, "W=")
	IF k <> 0 THEN word97 = VAL(MID$(par$, k + 2, 1))

	k = INSTR(par$, "F=")
	IF k = 0 THEN 165
	parf = VAL(MID$(par$, k + 2, 1))
	IF MID$(par$, k + 3, 1) = "X" THEN IF word97 <> 0 THEN xokraj = 1
	IF MID$(par$, k + 3, 1) = "Y" THEN IF word97 <> 0 THEN xokraj = 2
165     IF parf = 1 OR parf = 2 THEN fvel$ = "11111111"

	PRINT "Parametry: F="; STR$(parf);
	IF xokraj = 0 THEN 170
	PRINT "X";
	IF cad$ = "S" THEN 170
	PRINT
	PRINT "Pri pouziti X je mozny jen jednoduchy okraj"
	cad$ = "S"
170     PRINT " D="; STR$(pocdia); " O="; cad$; " C="; STR$(elimcz); " R="; STR$(solfon);
	IF parr <> 0 THEN PRINT "S";
	PRINT " N="; STR$(numb); " E="; STR$(coment);
	IF numsol <> 0 THEN PRINT "S";
	PRINT " T="; STR$(fonnum);
	PRINT " V="; fvel$;
	IF word97 = 4 THEN PRINT " (podle stylu)";
	PRINT " W="; STR$(word97)

	IF pocdia = 0 THEN texved = 1 ELSE texved = 0
	IF pocdia = 0 THEN pocdia = 1

	IF (parf < 1) OR (parf > 7) THEN 9090
	IF (fonnum < 1) OR (fonnum > 3) THEN 9090
	IF (pocdia < 1) OR (pocdia > 6) THEN 9090
	IF (cad$ <> "S") AND (cad$ <> "D") THEN 9090
	IF (elimcz < 0) OR (elimcz > 3) THEN 9090
	IF (coment < 0) OR (coment > 3) THEN 9090
	IF (solfon < 0) OR (solfon > 8) THEN 9090
	IF (word97 < 0) OR (word97 > 4) THEN 9090
	IF (numb <> 0) AND (numb <> 2) AND (numb <> 4) AND (numb <> 8) AND (numb <> 9) THEN 9090
	FOR i = 1 TO 8
	IF VAL(MID$(fvel$, i, 1)) < 0 OR VAL(MID$(fvel$, i, 1)) > 7 THEN 9090
	NEXT i

	IF fonnum = 1 AND xokraj = 1 THEN foname$ = CHR$(34) + "2Echecs" + CHR$(34)
	IF fonnum = 2 THEN foname$ = CHR$(34) + "DiagramTTHabsburg" + CHR$(34)
	IF fonnum = 3 THEN foname$ = CHR$(34) + "Cheq" + CHR$(34)

	DIM fsize(7)
	DIM fpix(7, 4)
	fsize(1) = 9
	fsize(2) = 10
	fsize(3) = 12
	fsize(4) = 14
	fsize(5) = 18
	fsize(6) = 24
	fsize(7) = 36


REM zatim pro velikost 5
	fpix(1, 1) = 8 * 12 + 2 ' cely diagram
	fpix(1, 2) = 20         ' vyzva a C+
	fpix(1, 3) = 20         ' pocet kamenu a cislo ulohy
	fpix(1, 4) = 12         ' mezera mezi diagramy
	fpix(2, 1) = 8 * 13 + 2
	fpix(2, 2) = 20
	fpix(2, 3) = 20
	fpix(2, 4) = 13
	fpix(3, 1) = 8 * 16 + 2
	fpix(3, 2) = 30
	fpix(3, 3) = 30
	fpix(3, 4) = 16
	fpix(4, 1) = 8 * 19 + 2
	fpix(4, 2) = 40
	fpix(4, 3) = 40
	fpix(4, 4) = 19
	fpix(5, 1) = 8 * 24 + 2 '194
	fpix(5, 2) = 50
	fpix(5, 3) = 40
	fpix(5, 4) = 24
	fpix(6, 1) = 9 * 24 + 2 '8 * 32 + 3
	fpix(6, 2) = 50         '60
	fpix(6, 3) = 40         '60
	fpix(6, 4) = 24         '32
	fpix(7, 1) = 8 * 48 + 4
	fpix(7, 2) = 80
	fpix(7, 3) = 80
	fpix(7, 4) = 48

	DIM tisk$(20, 6, 3)      ' max. 20 radek a 6 diagramu vedle sebe
	DIM typrad(20)
	GOSUB 2400

	GOSUB 3000

	DIM bx$(130)
	DIM nx$(130)
	GOSUB 9020

	DIM lhroh$(4)
	DIM hokraj$(4)
	DIM phroh$(4)
	DIM lokraj$(4)
	DIM pokraj$(4)
	DIM ldroh$(4)
	DIM dokraj$(4)
	DIM pdroh$(4)
	GOSUB 1380

	DIM cd$(11, 11)
	DIM kcitac(3)

	DIM notace$(4)
REM     ceska
	notace$(1) = "KDVSJPCT"
REM     nemecka
	notace$(2) = "KDTLSBGN"
REM     anglicka
	notace$(3) = "KQRBSPGN"
REM     francouzska
	notace$(4) = "RDTFCPSN"

	DIM not2$(4)
	not2$(1) = "TCWEKLVEADSPEL"
	not2$(2) = "NHWEKACAADSPEL"
	not2$(3) = "NHWAKACAEASPMO"
	not2$(4) = "NSWEKACAADSPEL"

REM dvojznakove kody exokamenu
	dvazn$ = "NHTCFEWELIROMAMOEQNEPAVALEKAKLDACAVEANFLALGIZEPEADSPELLHZHTHCHGNOK"
	jedzn$ = "N N F W L R M O E E X Y H H H X G G A Y A G Z G Y X H F Z W G G Z "

	notin = 1
	notout = 1
	kingt$ = "kkrr"
	bilyt$ = "bwwb"
	cernyt$ = "sbn"
REM R=2 jako R=1 s resenim v nemecke notaci
REM R=3 jako R=0 prevod z ceske do nemecke
REM R=4 jako R=0 prevod z ceske do anglicke
REM R=5 jako R=0 prevod z ceske do francouzske
REM R=6 jako R=0 prevod z nemecke do ceske
REM R=7 jako R=0 prevod z anglicke do ceske
REM R=8 jako R=0 prevod z francouzske do ceske
	IF solfon = 2 THEN notin = 2: notout = 1
	IF solfon = 3 THEN notin = 1: notout = 2
	IF solfon = 4 THEN notin = 1: notout = 3
	IF solfon = 5 THEN notin = 1: notout = 4
	IF solfon = 6 THEN notin = 2: notout = 1
	IF solfon = 7 THEN notin = 3: notout = 1
	IF solfon = 8 THEN notin = 4: notout = 1


	citac = 0
REM zacatek HTML souboru
	PRINT #4, "<HTML>"
	PRINT #4, "<HEAD>"
	PRINT #4, "</HEAD>"
	PRINT #4, "<META HTTP-EQUIV=" + CHR$(34) + "Content-Type" + CHR$(34) + " CONTENT=" + CHR$(34) + "text/html; charset=windows-1250" + CHR$(34) + ">"
	PRINT #4, "<META NAME=" + CHR$(34) + "Generator" + CHR$(34) + " CONTENT=" + CHR$(34) + "INPFONT " + ver$ + CHR$(34) + ">"
	PRINT #4, "<BODY bgcolor='#ffe0e0'>"
	solbeg = 0
	nl$ = ""
	first = 1
	GOTO 300

REM nova uloha
200     first = 0
	GOSUB 900
	IF coment = 3 THEN PRINT #4, "<TABLE cellpadding=0 cellspacing=0>"
	GOSUB 1900
	s$ = a$
	LINE INPUT #2, a$
	GOSUB 1900
	v$ = a$
	LINE INPUT #2, a$
	GOSUB 1900
	b$ = UCASE$(a$)
	LINE INPUT #2, a$
	GOSUB 1900
	c$ = UCASE$(a$)
	m = VAL(MID$(s$, 1, 2))
	n = VAL(MID$(s$, 3, 2))
	t = VAL(MID$(s$, 6, 1))
	IF t = 0 THEN typ$ = "N"
	IF t = 1 THEN typ$ = "V"
	IF t = 2 THEN typ$ = "H"
	IF t = 3 THEN typ$ = "T"
	typidx = t + 1
	citac = citac + 1
	fbodu = fsize(parf)
	GOSUB 1500

REM zacatek ulohy

REM texty nad diagramem
	tmode = 1
	nl$ = text1$
	GOSUB 2550
	tmode = 2
	nl$ = text2$
	GOSUB 2550

REM zde grafika diagramu
	fsize$ = STR$(parf)
	IF word97 <> 0 THEN 220
	tmode = 20
	nl$ = "<PRE><FONT FACE=" + foname$ + " Size=" + fsize$ + ">"
	GOSUB 2550
220     tmode = 10
	nl$ = ""
	GOSUB 1000
	IF word97 <> 0 THEN 230
	tmode = 20
	nl$ = "</FONT></PRE>"
230     GOSUB 2550

REM texty pod diagramem
	tmode = 3
	nl$ = vyzva$
	nl2$ = text3$
	nl3$ = pockam$
	GOSUB 2550

	tmode = 4
	nl$ = cplus$
	nl2$ = text4$
	IF numb = 9 THEN cisulo$ = STR$(citac)
	IF MID$(cisulo$, 1, 1) = " " THEN cisulo$ = MID$(cisulo$, 2)
	nl3$ = cisulo$
	GOSUB 2550

REM texty pod diagramy

REM zde reseni
	solbeg = 1
	nl$ = ""
	tmode = 5
	parrc = 0

300     IF EOF(2) THEN 9000
	GOSUB 2000
	IF k = 1 THEN 200
	IF coment > 1 THEN GOSUB 1900
	x$ = a$
	GOSUB 1830
	radres = 1
	h5zac$=""
	h5kon$="<BR>"
	IF parr <> 0 AND parrc <> 0 THEN 303
	GOSUB 8500
	h5zac$="<H5>"
	h5kon$="</H5>"
303     parrc = parrc + 1
	IF nl$ <> "" THEN 305
	IF numsol = 0 THEN 305
	IF word97 = 0 THEN y$ = "<BR>" + y$
	IF numb <> 0 THEN y$ = "<B>" + cisulo$ + " </B>" + y$

305     IF word97 <> 0 THEN 310
	nl$ = nl$ + y$ + "<BR>"
	IF first = 0 THEN 300 ELSE 320
310     IF word97 = 4 THEN nl$ = nl$ + h5zac$ + y$ + h5kon$ ELSE nl$ = nl$ + "<P align=justify>" + y$ + "</P>"
	IF first <> 0 THEN 320
	nl$ = nl$ + CHR$(13) + CHR$(10)
	GOTO 300
320     PRINT #4, nl$
	nl$ = ""
	GOTO 300


900     IF solbeg = 0 THEN 910
REM pripadny konec radek reseni
	tmode = 5
	IF texved = 1 THEN nl$ = nl$ + "<BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR>" + CHR$(13) + CHR$(10)
	GOSUB 2550
	solbeg = 0
910     GOSUB 2600
	RETURN


1000
REM horni okraj
	r$ = ""
	lom$ = lokraj$
	IF xokraj <> 0 THEN 1020
	IF yokraj <> 0 THEN IF fonnum = 1 THEN lom$ = "V"
	r$ = r$ + lhroh$(typidx)
	FOR i = 1 TO m
	r$ = r$ + hokraj$(typidx)
	IF yokraj <> 0 THEN r$ = r$ + hokraj$(typidx)
	NEXT i
	r$ = r$ + phroh$(typidx)
	IF yokraj <> 0 THEN r$ = r$ + "<FONT size=" + fsize$ + ">"
	IF word97 = 0 THEN nl$ = r$
	GOSUB 1400


REM telo diagramu
1020    IF INSTR(UCASE$(sendvi$), "@(G") = 0 THEN 1040
REM pripadna mrizkova sachovnice
	FOR j = 1 TO n
	FOR i = 1 TO m
	cd$(i, j) = ""
	NEXT i
	NEXT j
	IF fonnum <> 1 THEN 1040
	FOR j = 1 TO n
	FOR i = 1 TO m
	IF (2 * INT((i - 1) / 2) = i - 1) AND (i <> 1) THEN cd$(i, j) = cd$(i, j) + "V"
	IF (2 * INT((j - 1) / 2) <> j - 1) AND (j <> n) THEN 1030 ELSE 1035
1030    cd$(i, n - j + 1) = cd$(i, n - j + 1) + ""
	IF j <> n THEN cd$(i, n - j) = cd$(i, n - j) + "E"
1035    NEXT i
	NEXT j

1040    kcitac(1) = 0
	kcitac(2) = 0
	kcitac(3) = 0
	imit = 0
	xprik = 0

	FOR j = 1 TO n
	r$ = ""
	r$ = r$ + lokraj$(typidx)
	sraf$ = "0"
	IF 2 * (INT((n - j) / 2)) = n - j THEN sraf$ = "1"

	FOR i = 1 TO m

	pred$ = ""
	IF j = 1 THEN pred$ = CHR$(240)
	IF j = n THEN pred$ = CHR$(69)
	IF typidx = 3 OR typidx = 4 THEN pred$ = ""
	IF xokraj <> 0 THEN r$ = r$ + pred$

	gif$ = ""
	king$ = ""
	bk$ = ""
	barva = 0
	pole$ = CHR$(ASC("A") + i - 1) + CHR$(ASC("1") + n - j)
	IF INSTR(UCASE$(sendvi$), "@(G") THEN r$ = r$ + cd$(i, j)
	FOR k = 2 TO LEN(b$) STEP 3
	IF MID$(b$, k, 2) <> pole$ THEN 1090
	p$ = UCASE$(MID$(b$, k - 1, 1))
	GOSUB 9010
	IF pcode <> -1 THEN 1050
	GOSUB 1420
	GOTO 1090
1050    IF gif$ <> "" THEN GOSUB 1410
	IF k <> 2 THEN 1070
	IF MID$(b$, 1, 1) = "K" THEN 1070
	IF fonnum <> 1 THEN 1070
	IF (pcode = 11) OR (pcode = 12) OR (pcode = 17) OR (pcode = 18) OR (pcode = 19) OR (pcode = 26) OR (pcode = 30) THEN king$ = "&lt;" ELSE king$ = "&gt;"
1070    GOSUB 1370
	bk$ = p$ + king$ + gif$
	xbarva = barva
1090    NEXT k

	FOR k = 2 TO LEN(c$) STEP 3
	IF MID$(c$, k, 2) <> pole$ THEN 1190
	p$ = UCASE$(MID$(c$, k - 1, 1))
	GOSUB 9010
	IF pcode <> -1 THEN 1150
	GOSUB 1430
	GOTO 1190
1150    IF k <> 2 THEN 1170
	IF MID$(c$, 1, 1) = "K" THEN 1170
	IF fonnum <> 1 THEN 1170
	IF (pcode = 11) OR (pcode = 12) OR (pcode = 17) OR (pcode = 18) OR (pcode = 19) OR (pcode = 26) OR (pcode = 30) THEN king$ = "&lt;" ELSE king$ = "&gt;"
1170    barva = 1
	IF INSTR(UCASE$(vkpar$), "U") <> 0 THEN 1175
	kk = INSTR(UCASE$(vkpar$), "X")
	IF kk = 0 THEN 1180
	IF MID$(UCASE$(vkpar$), kk + 1, 2) <> pole$ THEN 1180
	IF MID$(UCASE$(vkpar$), kk + 3, 2) <> pole$ THEN 1180
REM napr.bez bK XE1E1 apod.
	IF xbarva <> 0 THEN 1180
	IF bk$ <> p$ + king$ + gif$ THEN 1180
	xprik = 1
	GOTO 1185
1175    IF bk$ = p$ + king$ + gif$ THEN barva = 2
1180    IF gif$ <> "" AND barva <> 2 THEN GOSUB 1440
1185    xbarva = barva
	GOSUB 1370
1190    NEXT k

	IF gif$ <> "" THEN kcitac(xbarva + 1) = kcitac(xbarva + 1) + 1

	k = INSTR(UCASE$(sendvi$), "@(I")
	IF k = 0 THEN 1300
	IF MID$(UCASE$(sendvi$), k + 3, 2) <> pole$ THEN 1300
	IF gif$ <> "" THEN GOSUB 1450
	p$ = MID$(UCASE$(sendvi$), k + 2, 1)
	GOSUB 9010
	IF pcode <> -1 THEN 1290
	GOSUB 1480
	GOTO 1295
1290    barva = 1
	king$ = ""
	GOSUB 1370
1295    imit = 1

1300    IF gif$ <> "" THEN 1350
	GOSUB 1360
	king$ = ""
1350    r$ = r$ + king$ + gif$
	sraf$ = CHR$(ASC("1") + ASC("0") - ASC(sraf$))
	NEXT i

	r$ = r$ + pokraj$(typidx)
	IF word97 = 0 THEN nl$ = r$
	GOSUB 1400
	NEXT j

	x$ = "(" + STR$(kcitac(1)) + "+" + STR$(kcitac(2))
	IF kcitac(3) <> 0 THEN x$ = x$ + "+" + STR$(kcitac(3))
	IF imit <> 0 THEN x$ = x$ + "+1"
	x$ = x$ + ")"
	GOSUB 1850
	pockam$ = y$
	IF 3 * (kcitac(1) + kcitac(2) + 2 * kcitac(3) + xprik) <> LEN(b$) + LEN(c$) THEN GOSUB 1460

REM dolni okraj
	r$ = ""
	IF xokraj <> 0 THEN RETURN
	IF yokraj <> 0 THEN r$ = r$ + "<FONT size=1>"
	r$ = r$ + ldroh$(typidx)
	FOR i = 1 TO m
	r$ = r$ + dokraj$(typidx)
	IF yokraj <> 0 THEN r$ = r$ + dokraj$(typidx)
	NEXT i
	r$ = r$ + pdroh$(typidx)
	IF word97 = 0 THEN nl$ = r$ ELSE nl$ = nl$ + r$
	IF word97 = 0 THEN GOSUB 1400
	RETURN

1360    IF fonnum = 1 THEN 1369
	IF fonnum = 2 THEN 1365
	IF sraf$ = "0" THEN gif$ = " " ELSE gif$ = "x"
	RETURN
1365    IF sraf$ = "0" THEN gif$ = "-" ELSE gif$ = "+"
	RETURN
1369    IF sraf$ = "0" THEN gif$ = " " ELSE gif$ = ":"
	RETURN


1370    IF fonnum = 1 THEN 1379
	IF barva = 2 THEN GOSUB 1470: barva = 0
	IF fonnum = 2 THEN 1375
REM             KDVSJP  srafovane
REM bile        kdtlsb  KDTLSB
REM cerne       bold    bold
	gif$ = MID$("kdtlsb", pcode, 1)
	IF sraf$ <> "0" THEN gif$ = UCASE$(gif$)
	IF barva = 1 THEN gif$ = "<B>" + gif$ + "</B>"
	RETURN
REM             KDVSJP  srafovane
REM bile        KQRLNP  mKwQtRvLsNzP
REM cerne       kqrlnp  mkwqtrvlsnzp
1375    gif$ = MID$("KQRLNP", pcode, 1)
	IF sraf$ <> "0" THEN gif$ = MID$("mKwQtRvLsNzP", 2 * pcode - 1, 2)
	IF barva = 1 THEN gif$ = LCASE$(gif$)
	RETURN
1379    IF sraf$ = "0" THEN gif$ = bx$(pcode * 3 + barva) ELSE gif$ = nx$(pcode * 3 + barva)
	RETURN


1380    IF fonnum = 1 THEN 1390
	FOR i = 1 TO 4
	lokraj$(i) = ""
	pokraj$(i) = ""
	hokraj$(i) = ""
	dokraj$(i) = ""
	lhroh$(i) = ""
	phroh$(i) = ""
	ldroh$(i) = ""
	pdroh$(i) = ""
	NEXT i

	IF fonnum <> 2 THEN RETURN
	lokraj$(1) = "9"
	pokraj$(1) = "0"
	hokraj$(1) = "I"
	dokraj$(1) = "i"
	lhroh$(1) = "X"
	phroh$(1) = "Y"
	ldroh$(1) = "x"
	pdroh$(1) = "y"

	lokraj$(2) = "9"
	pokraj$(2) = "0"
	hokraj$(2) = ""
	dokraj$(2) = ""
	lhroh$(2) = ""
	phroh$(2) = ""
	ldroh$(2) = ""
	pdroh$(2) = ""

	lokraj$(3) = ""
	pokraj$(3) = ""
	hokraj$(3) = "I"
	dokraj$(3) = "i"
	lhroh$(3) = ""
	phroh$(3) = ""
	ldroh$(3) = ""
	pdroh$(3) = ""

	lokraj$(4) = ""
	pokraj$(4) = ""
	hokraj$(4) = ""
	dokraj$(4) = ""
	lhroh$(4) = ""
	phroh$(4) = ""
	ldroh$(4) = ""
	pdroh$(4) = ""
	RETURN
1390    IF cad$ = "S" THEN 1395
REM N
	lhroh$(1) = "": hokraj$(1) = "": phroh$(1) = ""
	lokraj$(1) = "": pokraj$(1) = ""
	ldroh$(1) = "": dokraj$(1) = "": pdroh$(1) = ""
REM V
	lhroh$(2) = "": hokraj$(2) = "": phroh$(2) = ""
	lokraj$(2) = "": pokraj$(2) = ""
	ldroh$(2) = "": dokraj$(2) = "": pdroh$(2) = ""
REM H
	lhroh$(3) = "": hokraj$(3) = " ": phroh$(3) = ""
	lokraj$(3) = "": pokraj$(3) = ""
	ldroh$(3) = "": dokraj$(3) = " ": pdroh$(3) = ""
REM P
	lhroh$(4) = "": hokraj$(4) = " ": phroh$(4) = ""
	lokraj$(4) = "": pokraj$(4) = ""
	ldroh$(4) = "": dokraj$(4) = " ": pdroh$(4) = ""
	RETURN
1395    lhroh$(1) = "!": hokraj$(1) = "-": phroh$(1) = "!"
	lokraj$(1) = "/": pokraj$(1) = "/"
	ldroh$(1) = "$": dokraj$(1) = "_": pdroh$(1) = "$"

	lhroh$(2) = "": hokraj$(2) = "-": phroh$(2) = ""
	lokraj$(2) = "": pokraj$(2) = ""
	ldroh$(2) = "": dokraj$(2) = "_": pdroh$(2) = ""

	lhroh$(3) = "": hokraj$(3) = " ": phroh$(3) = ""
	lokraj$(3) = "/": pokraj$(3) = "/"
	ldroh$(3) = "": dokraj$(3) = " ": pdroh$(3) = ""

	lhroh$(4) = "": hokraj$(4) = " ": phroh$(4) = ""
	lokraj$(4) = "": pokraj$(4) = ""
	ldroh$(4) = "": dokraj$(4) = " ": pdroh$(4) = ""
	RETURN


1400    IF word97 = 0 THEN 1401
	IF r$ <> "" THEN nl$ = nl$ + r$ + "<BR>"
	RETURN
1401    IF r$ <> "" THEN GOSUB 2550
	RETURN


REM chybove stavy
1410    PRINT "Pozice c."; citac; " , chyba - dva bile kameny na poli "; pole$
	RETURN
1420    PRINT "Pozice c."; citac; " , chybny bily kamen "; p$
	RETURN
1430    PRINT "Pozice c."; citac; " , chybny cerny kamen "; p$
	RETURN
1440    PRINT "Pozice c."; citac; " , chyba - dva kameny na poli "; pole$;
	IF xbarva = 0 THEN PRINT " (bily a cerny)"
	IF xbarva = 1 THEN PRINT " (2 cerne)"
	IF xbarva = 2 THEN PRINT " (neutralni a cerny)"
	RETURN
1450    PRINT "Pozice c."; citac; " , chyba - pole imitatora "; pole$; " neni prazdne"
	RETURN
1460    PRINT "Pozice c."; citac; " chybna pole nebo nepripustne znaky"
	RETURN
1470    PRINT "Pozice c."; citac; " tento font neumoznuje neutralni kameny"
	RETURN
1480    PRINT "Pozice c."; citac; " tento font neumoznuje imitatora"
	RETURN


REM priprava textovych retezcu
1500    cplus$ = "C+"
	IF MID$(fvel$, 6, 1) = "0" THEN cplus$ = ""
	cisulo$ = ""
	text1$ = ""
	text2$ = ""
	text3$ = ""
	text4$ = ""
	vkpar$ = ""
	vyzva$ = v$
	koment$ = ""
	k = INSTR(v$, "'")
	IF k = 0 THEN 1600
	vyzva$ = MID$(v$, 1, k - 1)
	text1$ = MID$(v$, k + 1)

	k = INSTR(text1$, ",")
	IF k = 0 THEN 1600
	text2$ = MID$(text1$, k + 1)
	text1$ = MID$(text1$, 1, k - 1)
	k = INSTR(text2$, ",")
	IF k = 0 THEN 1540
	text3$ = MID$(text2$, k + 1)
	text2$ = MID$(text2$, 1, k - 1)
1540    IF numb <> 2 THEN 1550
	k = INSTR(text2$, CHR$(9) + " ")
	IF k = 0 THEN 1550
	cisulo$ = MID$(text2$, 1, k - 1)
	text2$ = MID$(text2$, k + 2)

1550    k = INSTR(text3$, ",")
	IF k = 0 THEN 1600
	text4$ = MID$(text3$, k + 1)
	text3$ = MID$(text3$, 1, k - 1)
	k = INSTR(text4$, ",")
	IF k <> 0 THEN text4$ = MID$(text4$, 1, k - 1)
	k = INSTR(text4$, "{")
	IF k = 0 THEN 1600
	tpar$ = MID$(text4$, k + 1)
	text4$ = MID$(text4$, 1, k - 1)
	IF INSTR(tpar$, "-") THEN cplus$ = ""

1600    IF numb <> 4 THEN 1620
	k = INSTR(text4$, CHR$(9) + " ")
	IF k = 0 THEN 1610
	cisulo$ = MID$(text4$, k + 2)
	text4$ = MID$(text4$, 1, k - 1)
	GOTO 1620
1610    cisulo$ = text4$
	text4$ = ""

1620    k = INSTR(vyzva$, "/")
	IF k = 0 THEN 1700
	vkpar$ = MID$(vyzva$, k + 1)
	vyzva$ = MID$(vyzva$, 1, k - 1)
REM     if instr(vkpar$,"Z") then ...

1700	gosub 1750
	x$ = text1$
	GOSUB 1820
	text1$ = y$
	x$ = text2$
	GOSUB 1820
	text2$ = y$
	x$ = text3$
	GOSUB 1820
	radres = 0
	GOSUB 8500
	text3$ = y$
	x$ = text4$
	GOSUB 1820
	radres = 0
	GOSUB 8500
	text4$ = y$
	RETURN

1750	sendvi$=""
	k=instr(vkpar$,"@(")
	if k=0 then return
	sendvi$=mid$(vkpar$,k)
	vkpar$=mid$(vkpar$,1,k-1)
	kk=instr(sendvi$,")")
	if kk=0 then return
	vkpar$=vkpar$+mid$(sendvi$,kk+1)
	sendvi$=mid$(sendvi$,1,kk)
	RETURN


REM zamena znaku _ na carku
1800    y$ = ""
	sipka = 0
	jetag = 0
	FOR k = 1 TO LEN(x$)
	IF sipka = 0 THEN 1801
	sipka = 0
	GOTO 1810
1801    z$ = MID$(x$, k, 1)
REM     IF z$ = ">" THEN z$ = "&gt;": GOTO 1805
REM     IF z$ = "<" THEN z$ = "&lt;": GOTO 1805
	IF MID$(x$, k, 2) <> "<>" THEN 1802
	z$ = "<FONT FACE=" + CHR$(34) + "Symbol" + CHR$(34) + "></FONT>"
	sipka = 1
	GOTO 1805
1802    IF z$ = "<" THEN jetag = 1
	IF jetag = 0 THEN 1803
	IF z$ = ">" THEN jetag = 0
	GOTO 1804
1803    IF z$ = ">" THEN z$ = "<FONT FACE=" + CHR$(34) + "Symbol" + CHR$(34) + "></FONT>": GOTO 1805
REM     IF z$ = "<" THEN z$ = "<FONT FACE=" + CHR$(34) + "Symbol" + CHR$(34) + "></FONT>": GOTO 1805
1804    IF z$ = "&" THEN z$ = "&amp;": GOTO 1805
REM znak stupne
	IF z$ = "" THEN z$ = CHR$(176)
	IF z$ = "_" THEN z$ = ","
	IF elimcz = 2 THEN 1805
	IF elimcz = 3 AND radres = 1 THEN 1805
REM pripadna eliminace cestiny
	IF z$ = "~" THEN 1810
	IF z$ = "`" THEN 1810
	IF z$ = "\" THEN 1810
	IF k = LEN(x$) THEN z2$ = "" ELSE z2$ = MID$(x$, k + 1, 1)
	IF elimcz = 0 THEN z2$ = ""
	zcode = ASC(z$) - ASC("A")
	IF zcode < 0 THEN 1805
	IF zcode > 57 THEN 1805
REM pripadny prevod cestiny
	IF z2$ = "~" THEN z$ = MID$(thck$, zcode + 1, 1)
	IF z2$ = "`" THEN z$ = MID$(tcrk$, zcode + 1, 1)
	IF z2$ = "\" THEN z$ = MID$(tpre$, zcode + 1, 1)
1805    y$ = y$ + z$
1810    NEXT k
	RETURN

REM nahradit ==  = =
REM  --  ~

1820    radres = 0
	GOTO 1800
1830    radres = 1
	GOTO 1800

REM vyhazeni nadbytecnych mezer
1850    y$ = ""
	FOR k = 1 TO LEN(x$)
	z$ = MID$(x$, k, 1)
	IF z$ <> " " THEN y$ = y$ + z$
	NEXT k
	RETURN


1900    IF coment = 0 THEN RETURN
	y$ = ""
	FOR k = 1 TO LEN(a$)
	z$ = MID$(a$, k, 1)
	IF z$ = ">" THEN z$ = "&gt;"
	IF z$ = "<" THEN z$ = "&lt;"
	IF z$ = "&" THEN z$ = "&amp;"
	y$ = y$ + z$
	NEXT k
REM     PRINT #4, "<!"; y$; ">"
	PRINT #4, "<COMMENT>!!!"; y$; "<BR></COMMENT>"
	RETURN


2000    LINE INPUT #2, a$
	k = 0
	IF LEN(a$) <> 6 THEN RETURN
	k = INSTR(a$, " 8 8 0")
	IF k <> 0 THEN RETURN
	IF MID$(a$, 1, 2) = "10" THEN 2100
	IF MID$(a$, 1, 1) <> " " THEN RETURN
	IF MID$(a$, 2, 1) = "1" THEN 2100
	IF MID$(a$, 2, 1) = "2" THEN 2100
	IF MID$(a$, 2, 1) = "3" THEN 2100
	IF MID$(a$, 2, 1) = "4" THEN 2100
	IF MID$(a$, 2, 1) = "5" THEN 2100
	IF MID$(a$, 2, 1) = "6" THEN 2100
	IF MID$(a$, 2, 1) = "7" THEN 2100
	IF MID$(a$, 2, 1) = "8" THEN 2100
	IF MID$(a$, 2, 1) = "9" THEN 2100
	RETURN
2100    IF MID$(a$, 3, 2) = "10" THEN 2200
	IF MID$(a$, 3, 1) <> " " THEN RETURN
	IF MID$(a$, 4, 1) = "1" THEN 2200
	IF MID$(a$, 4, 1) = "2" THEN 2200
	IF MID$(a$, 4, 1) = "3" THEN 2200
	IF MID$(a$, 4, 1) = "4" THEN 2200
	IF MID$(a$, 4, 1) = "5" THEN 2200
	IF MID$(a$, 4, 1) = "6" THEN 2200
	IF MID$(a$, 4, 1) = "7" THEN 2200
	IF MID$(a$, 4, 1) = "8" THEN 2200
	IF MID$(a$, 4, 1) = "9" THEN 2200
	RETURN
2200    IF MID$(a$, 5, 1) <> " " THEN RETURN
	IF MID$(a$, 6, 1) = "0" THEN 2300
	IF MID$(a$, 6, 1) = "1" THEN 2300
	IF MID$(a$, 6, 1) = "2" THEN 2300
	IF MID$(a$, 6, 1) = "3" THEN 2300
	RETURN
2300    k = 1
	RETURN


REM tiskove pole inicializace
2400    FOR ii = 1 TO 20
	typrad(ii) = 0
	FOR jj = 1 TO pocdia
	tisk$(ii, jj, 1) = ""
	tisk$(ii, jj, 2) = ""
	tisk$(ii, jj, 3) = ""
	NEXT jj
	NEXT ii
	actdia = 0
	nlinem = 0
	nline = 0
	RETURN

REM tmode=
REM 20          radka jednorazova
REM 1           text1
REM 2           text2
REM 3           text3
REM 4           text4
REM 5           reseni
REM 10          diagramy

2550    nline = nline + 1
	typrad(nline) = tmode
	IF nline > 20 THEN PRINT "Chyba - vice jak 20 radek u 1 pozice"
	IF nline > nlinem THEN nlinem = nline
	tisk$(nline, actdia + 1, 1) = nl$
	IF tmode = 3 THEN 2560
	IF tmode <> 4 THEN RETURN
2560    tisk$(nline, actdia + 1, 2) = nl2$
	tisk$(nline, actdia + 1, 3) = nl3$
	RETURN


REM vyprazdneni tiskoveho pole

2600    IF nline = 0 THEN RETURN
	nline = 0
	actdia = actdia + 1
	IF actdia <> pocdia THEN RETURN
	IF nlinem = 0 THEN RETURN

	r1$ = STR$(fpix(parf, 1))
	r2$ = STR$(fpix(parf, 2))
	r3$ = STR$(fpix(parf, 3))
	r4$ = STR$(fpix(parf, 4))
	r5$ = STR$(fpix(parf, 1) - fpix(parf, 2) - fpix(parf, 3))
	rd$ = STR$(fpix(parf, 1) + fpix(parf, 4))
	IF word97 = 0 THEN 2700
	widtab$ = ""
	wid$ = " width="
	align$ = " align=center>"
	IF fonnum = 3 THEN align$ = " align=left>"
	IF word97 = 1 THEN 2610

	IF word97 <> 3 THEN 2605
REM bez atributu center
	align$ = ">"
	rd$ = STR$(fpix(parf, 1) + fpix(parf, 4) * 3)

2605    IF pocdia <> 3 THEN 2610
	IF parf <> 3 AND parf <> 5 THEN 2610
REM pro F=5 D=3 a format A4 je
	widtab$ = " width=623"
REM specialni, pro F=3 D=3 a format A5
	IF parf = 3 THEN widtab$ = " width=425"
	wid$ = " width="
	r1$ = "'33%'"
	r2$ = "'9%'"
	r3$ = "'9%'"
	r4$ = ""
	r5$ = "'15%'"
	rd$ = "'33%'"

REM pro WORD97 s pouzitim tabulek pro diagramy (mohou pak byt vedle sebe valcove sachovnice,
REM lze jednoduseji manipulovat s jednotlivymi diagramy atd.
REM W=1
2610    IF word97 = 4 THEN 2800

	FOR ii = 1 TO nlinem
	tp = typrad(ii)
	IF tp = 1 THEN PRINT #4, "<TABLE cellpadding=0 cellspacing=0"; widtab$; ">"
	jetr = 0
	IF tp < 5 OR tp = 10 THEN jetr = 1

	IF redukr = 0 THEN 2615
	IF tp > 4 THEN 2615
REM pripadne vylouceni prazdnych radku v tabulce
	FOR jj = 1 TO pocdia
	IF tisk$(ii, jj, 1) <> "" THEN 2615
	IF tp < 3 THEN 2612
	IF tisk$(ii, jj, 2) <> "" THEN 2615
	IF tisk$(ii, jj, 3) <> "" THEN 2615
2612    NEXT jj
	GOTO 2660
2615    IF jetr = 1 THEN PRINT #4, "<TR>";

	FOR jj = 1 TO pocdia
	IF tp = 1 THEN PRINT #4, "<TH colspan=3"; wid$; r1$; " align=center><FONT size="; MID$(fvel$, 1, 1); ">";
	IF tp = 2 THEN PRINT #4, "<TD colspan=3"; wid$; r1$; " align=center><FONT size="; MID$(fvel$, 2, 1); ">";
	IF tp = 3 THEN PRINT #4, "<TH"; wid$; r2$; " align=center><FONT size="; MID$(fvel$, 3, 1); ">";
	IF tp = 4 THEN PRINT #4, "<TD"; wid$; r2$; " align=center><FONT size="; MID$(fvel$, 6, 1); "><I>";
	IF tp <> 10 THEN 2620
	PRINT #4, "<TD colspan=3"; wid$; rd$; align$;
	PRINT #4, "<PRE>";
	PRINT #4, "<FONT FACE=" + foname$ + " Size=";
	IF yokraj = 0 THEN PRINT #4, fsize$;  ELSE PRINT #4, "1";
	PRINT #4, ">";
2620    PRINT #4, tisk$(ii, jj, 1);
	IF tp <> 10 THEN 2625
	IF yokraj <> 0 THEN PRINT #4, "</FONT></FONT>";
	PRINT #4, "</FONT>";
	PRINT #4, "</PRE>";
	PRINT #4, "</TD>"
2625    IF tp <> 3 THEN 2630
	PRINT #4, "<TD"; wid$; r5$; " align=center><FONT size="; MID$(fvel$, 4, 1); ">";
	PRINT #4, tisk$(ii, jj, 2);
	PRINT #4, "<TD"; wid$; r3$; " align=center><FONT size="; MID$(fvel$, 5, 1); ">";
	PRINT #4, tisk$(ii, jj, 3);
2630    IF tp <> 4 THEN 2640
	PRINT #4, "<TD"; wid$; r5$; " align=center><FONT size="; MID$(fvel$, 7, 1); ">";
	PRINT #4, tisk$(ii, jj, 2);
	PRINT #4, "<TH"; wid$; r3$; " align=center><FONT size="; MID$(fvel$, 8, 1); ">";
	PRINT #4, tisk$(ii, jj, 3);
2640
2650    NEXT jj
	IF jetr = 1 THEN PRINT #4, "</TR>"
2660    IF tp = 4 THEN PRINT #4, "</TABLE>"
	NEXT ii

	GOTO 2400


REM vystup diagramu bez tabulek
REM nutny pro IE4
REM W=0
2700    FOR ii = 1 TO nlinem
	tp = typrad(ii)
	IF (tp = 1) OR (tp = 3) THEN PRINT #4, "<TABLE cellpadding=0 cellspacing=0>"
	IF tp < 5 THEN PRINT #4, "<TR>";

	FOR jj = 1 TO pocdia
	IF (tp = 20) AND (jj <> 1) THEN 2750
	IF tp = 1 THEN PRINT #4, "<TH width="; r1$; " align=center><FONT size="; MID$(fvel$, 1, 1); ">";
	IF tp = 2 THEN PRINT #4, "<TD width="; r1$; " align=center><FONT size="; MID$(fvel$, 2, 1); ">";
	IF tp = 3 THEN PRINT #4, "<TH width="; r2$; " align=left><FONT size="; MID$(fvel$, 3, 1); ">";
	IF tp = 4 THEN PRINT #4, "<TD width="; r2$; "><FONT size="; MID$(fvel$, 6, 1); "><I>";
	PRINT #4, tisk$(ii, jj, 1);
	IF tp <> 3 THEN 2730
	PRINT #4, "<TD width="; r5$; " align=center><FONT size="; MID$(fvel$, 4, 1); ">";
	PRINT #4, tisk$(ii, jj, 2);
	PRINT #4, "<TD width="; r3$; " align=right><FONT size="; MID$(fvel$, 5, 1); ">";
	PRINT #4, tisk$(ii, jj, 3);
2730    IF tp <> 4 THEN 2740
	PRINT #4, "<TD width="; r5$; " align=center><FONT size="; MID$(fvel$, 7, 1); ">";
	PRINT #4, tisk$(ii, jj, 2);
	PRINT #4, "<TH width="; r3$; " align=right><FONT size="; MID$(fvel$, 8, 1); ">";
	PRINT #4, tisk$(ii, jj, 3);
2740    IF jj = pocdia THEN 2750
	IF tp = 10 THEN PRINT #4, " ";
	IF tp < 5 THEN PRINT #4, "<TD width="; r4$; ">"
2750    NEXT jj
	IF tp = 5 THEN PRINT #4, "<BR>"
	IF tp = 10 THEN PRINT #4, "<BR>";
	IF tp < 5 THEN PRINT #4, "</TR>"
	IF (tp = 2) OR (tp = 4) THEN PRINT #4, "</TABLE>"
2760    NEXT ii

	GOTO 2400


REM W=4
REM styly
2800	if pocdia<>1 then 2805
	if parf<>6 then 2805
rem specialni format pro vyber mych uloh
	r1$="288"
rem kdyz sachovnice 9x9 nebo 10x10, vetsi
	if m=9 then r1$="296"
	if m=10 then r1$="328"
	widtab$=" width="+r1$
	rd$=r1$
	r2$="50"
	r5$="150"
	if m=9 then r5$="160"
	if m=10 then r5$="180"
	r3$="60"

2805    IF texved = 1 THEN widtab$ = widtab$ + " align=left"
	FOR ii = 1 TO nlinem
	tp = typrad(ii)
	IF tp = 1 AND coment <> 3 THEN PRINT #4, "<TABLE cellpadding=0 cellspacing=0"; widtab$; ">"
	jetr = 0
	IF tp < 5 OR tp = 10 THEN jetr = 1
	IF redukr = 0 THEN 2815
	IF tp > 4 THEN 2815
	IF tp = 4 AND numb = 8 THEN 2815
	FOR jj = 1 TO pocdia
	IF tisk$(ii, jj, 1) <> "" THEN 2815
	IF tp < 3 THEN 2812
	IF tisk$(ii, jj, 2) <> "" THEN 2815
	IF tisk$(ii, jj, 3) <> "" THEN 2815
2812    NEXT jj
	GOTO 2860
2815    IF jetr = 1 THEN PRINT #4, "<TR>";

	FOR jj = 1 TO pocdia
	IF tp = 1 THEN PRINT #4, "<TD colspan=3"; wid$; r1$; "><H1>";
	IF tp = 2 THEN PRINT #4, "<TD colspan=3"; wid$; r1$; "><H2>";
	IF tp = 3 THEN PRINT #4, "<TD"; wid$; r2$; "><H4>";
	IF tp = 4 THEN PRINT #4, "<TD"; wid$; r2$; "><H3>";
	IF tp > 4 THEN 2818
	IF tisk$(ii, jj, 1) = "" THEN tisk$(ii, jj, 1) = "&nbsp;"
	IF tisk$(ii, jj, 2) = "" THEN tisk$(ii, jj, 2) = "&nbsp;"
	IF tisk$(ii, jj, 3) = "" THEN tisk$(ii, jj, 3) = "&nbsp;"
2818    IF tp <> 10 THEN 2820
	PRINT #4, "<TD colspan=3"; wid$; rd$; ">"; "<H6>";
2820    PRINT #4, tisk$(ii, jj, 1);
	IF tp <> 10 THEN 2825
	PRINT #4, "</H6>";
	PRINT #4, "</TD>"
2825    IF tp = 1 THEN PRINT #4, "</H1>";
	IF tp = 2 THEN PRINT #4, "</H2>";
	IF tp = 3 THEN PRINT #4, "</H4>";
	IF tp = 4 THEN PRINT #4, "</H3>";
	IF tp <> 3 THEN 2830
	PRINT #4, "<TD"; wid$; r5$; "><H3>"; tisk$(ii, jj, 2); "</H3>";
	PRINT #4, "<TD"; wid$; r3$; "><H3>"; tisk$(ii, jj, 3); "</H3>";
2830    IF tp <> 4 THEN 2840
	PRINT #4, "<TD"; wid$; r5$; "><H3>"; tisk$(ii, jj, 2); "</H3>";
	IF numb <> 8 THEN PRINT #4, "<TD"; wid$; r3$; "><H4>"; tisk$(ii, jj, 3); "</H4>";
	IF numb = 8 THEN PRINT #4, "<TD"; wid$; r3$; "><PRE>"; tisk$(ii, jj, 3); "</PRE>";
2840
2850    NEXT jj
	IF jetr = 1 THEN PRINT #4, "</TR>"
2860    IF tp = 4 THEN PRINT #4, "</TABLE>"
	NEXT ii

	GOTO 2400




REM prevod cestiny
3000    tcrk$ = "                                            "
	thck$ = "            ؊                          "
	tpre$ = "                                                    "

	RETURN

REM pripadny prevod na diagramove fonty
REM obtizna je definice, co se z textu ma povazovat za figury a substituovat fontem
REM jsou to slova zacinajici velkym pismenem a ukoncena cislem
REM po cisle mohou nasledovat znaky # = == X +
REM zacatkem slova je tecka nebo mezera
REM ukoncenim slova je mezera, carka, tecka nebo konec radky
8500    IF solfon = 0 THEN RETURN
	a$ = y$
	idx1 = 1
	oldbar = 1
	oldbari = 1
	IF INSTR(UCASE$(vyzva$), "H#") THEN 8505
	IF INSTR(UCASE$(vyzva$), "H=") THEN 8505
	idx1 = 2
	oldbar = 0
	oldbari = 0
8505    y$ = ""
	i = 1
8520    IF i > LEN(a$) THEN RETURN
	x$ = MID$(a$, i, 1)
	if x$="." then oldbar=oldbari
	if x$="-" then oldbar=1-oldbari
	kral = 0
	IF i <> 1 THEN 8522
	IF radres = 1 THEN 8580
	xsep$ = " "
	GOTO 8523
8522    xsep$ = MID$(a$, i - 1, 1)
8523    xsep = i - 1

	IF ASC(x$) < ASC("A") THEN 8580
	IF ASC(x$) > ASC("Z") THEN 8580
REM zde jsem nasel velke pismeno
	posun = 0
REM procedura proveri pripustne dvojice velkych pismen s konverzi na jednoznakovou grafiku
	GOSUB 8900

	IF MID$(a$, i + 1, 1) = "K" THEN kral = 1: i = i + 1
	IF i + 2 > LEN(a$) THEN 8524
	IF ASC(MID$(a$, i + 1, 1)) < ASC("A") THEN 8524
	IF ASC(MID$(a$, i + 1, 1)) > ASC("Z") THEN 8524
REM pokud jsou 2 velka pismena (mimo pripustne dvojice) za sebou, nebudu prevadet na fonty
	IF kral = 1 THEN x$ = x$ + "K"
	kral = 0
	i = i + 1
	x$ = x$ + MID$(a$, i, 1)
	GOTO 8580

8524    IF i + 2 > LEN(a$) THEN 8525
	xcislo$ = MID$(a$, i + 2, 1)
	xsloup$ = MID$(a$, i + 1, 1)
	IF ASC(xsloup$) < ASC("a") THEN 8525
	IF ASC(xsloup$) > m - 1 + ASC("a") THEN 8525
	IF ASC(xcislo$) < ASC("1") THEN 8525
	IF ASC(xcislo$) > n + ASC("0") THEN 8525
	posun = 3
	GOTO 8530

REM zde pripady typu Jde7 J3e7 J:e7 Jxe7
8525    IF i + 3 > LEN(a$) THEN 8527
	xcislo$ = MID$(a$, i + 3, 1)
	xsloup$ = MID$(a$, i + 2, 1)
	xspec$ = MID$(a$, i + 1, 1)
	IF ASC(xsloup$) < ASC("a") THEN 8527
	IF ASC(xsloup$) > m - 1 + ASC("a") THEN 8527
	IF ASC(xcislo$) < ASC("1") THEN 8527
	IF ASC(xcislo$) > n + ASC("0") THEN 8527
	IF xspec$ = ":" THEN 8526
	IF xspec$ = "x" THEN 8526
	GOSUB 8590
	IF ok = 0 THEN 8527
8526    posun = 4
	GOTO 8530

REM Jd:e7 J3xe7
8527    IF i + 4 > LEN(a$) THEN 8528
	xcislo$ = MID$(a$, i + 4, 1)
	xsloup$ = MID$(a$, i + 3, 1)
	IF ASC(xsloup$) < ASC("a") THEN 8528
	IF ASC(xsloup$) > m - 1 + ASC("a") THEN 8528
	IF ASC(xcislo$) < ASC("1") THEN 8528
	IF ASC(xcislo$) > n + ASC("0") THEN 8528
	xspec$ = MID$(a$, i + 1, 1)
	GOSUB 8590
	IF ok = 0 THEN 8528
	xspec$ = MID$(a$, i + 2, 1)
	posun = 5
	IF xspec$ = ":" THEN 8530
	IF xspec$ = "x" THEN 8530

8528    IF i < 3 THEN 8580
	izpet = 1
	IF kodp2 <> 0 THEN izpet = izpet + 1
	IF MID$(a$, i - izpet, 1) = "n" THEN izpet = izpet + 1
	xcislo$ = MID$(a$, i - izpet, 1)
	xsloup$ = MID$(a$, i - izpet - 1, 1)
	IF ASC(xsloup$) < ASC("a") THEN 8580
	IF ASC(xsloup$) > m - 1 + ASC("a") THEN 8580
	posun = 0
	IF ASC(xcislo$) = ASC("1") THEN 8529
	IF ASC(xcislo$) <> n + ASC("0") THEN 8580
REM promena
8529    IF xsep = 1 THEN 8530
	IF MID$(a$, xsep, 1) = "." THEN 8530
	IF MID$(a$, xsep, 1) = " " THEN 8530
	IF MID$(a$, xsep, 1) = "," THEN 8530
	IF MID$(a$, xsep, 1) = "/" THEN 8530
	IF MID$(a$, xsep, 1) = "n" THEN 8530
	xsep = xsep - 1
	GOTO 8529

8530    GOSUB 8600
REM ignorovani pro nekolik dalsich znaku
8535    i = i + 1
	IF posun = 0 THEN 8520
	IF i > LEN(a$) THEN RETURN
	y$ = y$ + MID$(a$, i, 1)
	posun = posun - 1
	GOTO 8535

8580    IF kral = 1 THEN x$ = x$ + "K"
	y$ = y$ + x$
	i = i + 1
	GOTO 8520

8590    ok = 0
	IF ASC(xspec$) < ASC("a") THEN 8592
	IF ASC(xspec$) > m - 1 + ASC("a") THEN 8592
	ok = 1
	RETURN
8592    IF ASC(xspec$) < ASC("1") THEN RETURN
	IF ASC(xspec$) > n + ASC("0") THEN RETURN
	ok = 1
	RETURN

REM vystup sach.fontu kamene
8600	tvrdab=-1
	IF radres = 1 THEN 8602
	IF xsep = 0 THEN 8601
	IF MID$(a$, xsep, 1) = "." THEN 8610
8601    barva = -1
	IF INSTR(b$, UCASE$(MID$(a$, xsep + 1, 3))) THEN barva = barva + 1
	IF INSTR(c$, UCASE$(MID$(a$, xsep + 1, 3))) THEN barva = barva + 2
	IF barva = -1 THEN 8680
	IF barva = 0 THEN 8670
	IF barva = 1 THEN 8670
	IF INSTR(UCASE$(vkpar$), "U") THEN 8670
	GOTO 8680
8602    IF xsep = 1 THEN 8610
	IF MID$(a$, xsep, 1) = "." THEN 8610
	IF MID$(a$, xsep, 1) = "," THEN 8605
	IF MID$(a$, xsep, 1) = "/" THEN 8605
	IF MID$(a$, xsep, 1) = "(" THEN 8603
	IF MID$(a$, xsep, 1) = "n" THEN 8604
	IF MID$(a$, xsep, 1) = "b" THEN 8606
	IF MID$(a$, xsep, 1) = "" THEN 8607
	IF MID$(a$, xsep, 1) <> " " THEN 8610
	xsep = xsep - 1
	GOTO 8602
8603    IF INSTR(UCASE$(vkpar$), "C") = 0 THEN 8605
	IF barva <> 2 THEN barva = 1 - barva
	GOTO 8670
8604    barva = 2
	y$ = MID$(y$, 1, LEN(y$) - 1)
	GOTO 8670
8605    barva = oldbar
	GOTO 8670
8606    barva = 0
	GOTO 8608
8607    barva = 1
8608	y$ = MID$(y$, 1, LEN(y$) - 1)
	tvrdab=barva
	GOTO 8671
8610    barva = 0
	IF idx1 = 2 THEN 8650
	IF MID$(a$, xsep, 1) = "." THEN 8660
	GOTO 8670
REM kdyz prima uloha, nejprve bily
8650    IF MID$(a$, xsep, 1) = "." THEN 8670
8660    barva = 1
8670    oldbar = barva
	IF x$ = "I" THEN barva = 1
8671	p$ = x$
	GOSUB 8800
	IF solfon < 3 THEN 8672
	IF barva = 2 THEN y$ = y$ + "n"
	if tvrdab=0 then y$ = y$ + mid$(bilyt$,notout,1)
	if tvrdab=1 then y$ = y$ + mid$(cernyt$,notout,1)
	y$ = y$ + p$
	IF kral = 1 THEN y$ = y$ + "K"
	RETURN
8672    IF LEN(p$) = 2 AND kodp2 <> 0 THEN p$ = MID$(jedzn$, kodp2, 1)
	GOSUB 9010
	IF pcode = -1 THEN 8680
	king$ = ""
	IF kral = 0 THEN 8675
rem doplneni znaku k nebo r pred kralovsky kamen kvuli lepsi rozlisitelnosti v reseni (krizek je malo)
	y$ = y$ + mid$(kingt$,notout,1)
	IF (pcode = 11) OR (pcode = 12) OR (pcode = 17) OR (pcode = 18) OR (pcode = 19) OR (pcode = 26) OR (pcode = 30) THEN king$ = "&lt;" ELSE king$ = "&gt;"
8675    sraf$ = "0"
	GOSUB 1370
	IF fonnum <> 1 THEN king$ = ""
	y$ = y$ + "<FONT FACE=" + foname$ + " Size=2>" + king$ + gif$ + "</FONT>"
	RETURN
8680    IF kral = 1 THEN x$ = x$ + "K"
	y$ = y$ + x$
	RETURN


REM prevody mezi notacemi
REM     ceska=1       "KDVSJPCT"
REM     nemecka=2     "KDTLSBGN"
REM     anglicka=3    "KQRBSPGN"
REM     francouzska=4 "RDTFCPSN"
REM parametry notin=kod vstupni notace
REM           notout=kod vystupni notace
REM           p$ = kod kamene
REM delka p$ je obvykle 1 s vyjimkou pripadu TC NH apod.
8800    IF solfon < 2 THEN RETURN
	IF LEN(p$) = 2 THEN 8810
	IF LEN(p$) <> 1 THEN RETURN
	pcode2 = INSTR(notace$(notin), p$)
	IF pcode2 = 0 THEN RETURN
	p$ = MID$(notace$(notout), pcode2, 1)
	RETURN
8810    FOR pcode2 = 1 TO LEN(not2$(notin)) STEP 2
	IF MID$(not2$(notin), pcode2, 2) = p$ THEN 8820
	NEXT pcode2
	RETURN
8820    p$ = MID$(not2$(notout), pcode2, 2)
	RETURN


REM prevod dvojznakovych kodu na unifikovanou grafiku
8900    FOR kodp2 = 1 TO LEN(dvazn$) STEP 2
	IF MID$(a$, i, 2) = MID$(dvazn$, kodp2, 2) THEN 8910
	NEXT kodp2
	kodp2 = 0
	RETURN
8910    x$ = MID$(a$, i, 2)
	i = i + 1
	RETURN


REM konec
9000    pocdia = actdia + 1
	GOSUB 900
	PRINT "Celkovy pocet pozic "; citac
REM konec HTML souboru
	PRINT #4, "</BODY>"
	PRINT #4, "</HTML>"
	GOTO 9100


REM kody kamenu a exokamenu kompatibilni s VKSACHem
9010    pcode = -1
	IF fonnum = 1 THEN 9018
	IF p$ = "K" THEN pcode = 1
	IF p$ = "D" THEN pcode = 2
	IF p$ = "V" THEN pcode = 3
	IF p$ = "S" THEN pcode = 4
	IF p$ = "J" THEN pcode = 5
	IF p$ = "P" THEN pcode = 6
	RETURN

9018    pcode = -1
	IF p$ = "A" THEN pcode = 19
	IF p$ = "B" THEN pcode = 26
	IF p$ = "C" THEN pcode = 8
	IF p$ = "D" THEN pcode = 3
	IF p$ = "E" THEN pcode = 17
	IF p$ = "F" THEN pcode = 16
	IF p$ = "G" THEN pcode = 35
	IF p$ = "H" THEN pcode = 13
	IF p$ = "I" THEN pcode = 31
	IF p$ = "J" THEN pcode = 6
	IF p$ = "K" THEN pcode = 0
	IF p$ = "L" THEN pcode = 9
	IF p$ = "M" THEN pcode = 34
	IF p$ = "N" THEN pcode = 10
	IF p$ = "O" THEN pcode = 33     '27
	IF p$ = "P" THEN pcode = 1
	IF p$ = "Q" THEN pcode = 18
	IF p$ = "R" THEN pcode = 32
	IF p$ = "S" THEN pcode = 5
	IF p$ = "T" THEN pcode = 7
	IF p$ = "U" THEN pcode = 30
	IF p$ = "V" THEN pcode = 4
	IF p$ = "W" THEN pcode = 15
	IF p$ = "X" THEN pcode = 11
	IF p$ = "Y" THEN pcode = 12
	IF p$ = "Z" THEN pcode = 14

	RETURN

REM puvodni francouzske kody
9019    pcode = -1
	IF p$ = "R" THEN pcode = 0
	IF p$ = "D" THEN pcode = 3
	IF p$ = "T" THEN pcode = 4
	IF p$ = "F" THEN pcode = 5
	IF p$ = "C" THEN pcode = 6
	IF p$ = "N" THEN pcode = 7
	IF p$ = "S" THEN pcode = 8
	IF p$ = "P" THEN pcode = 1
	IF p$ = "B" THEN pcode = 2
	IF p$ = "E" THEN pcode = 17
	IF p$ = "I" THEN pcode = 31
	IF p$ = "O" THEN pcode = 15
	IF p$ = "J" THEN pcode = 16
	IF p$ = "G" THEN pcode = 10
	IF p$ = "H" THEN pcode = 14
	IF p$ = "U" THEN pcode = 13
	IF p$ = "W" THEN pcode = 9
	IF p$ = "K" THEN pcode = 28
	IF p$ = "L" THEN pcode = 12
	IF p$ = "M" THEN pcode = 19
	IF p$ = "X" THEN pcode = 29
	IF p$ = "Y" THEN pcode = 11
	IF p$ = "Z" THEN pcode = 18
	IF p$ = "A" THEN pcode = 30
	IF p$ = "Q" THEN pcode = 27
	IF p$ = "V" THEN pcode = 26
	IF p$ = "h" THEN pcode = 32
	IF p$ = "i" THEN pcode = 33
	IF p$ = "j" THEN pcode = 34
	IF p$ = "k" THEN pcode = 35
	IF p$ = "l" THEN pcode = 22
	IF p$ = "m" THEN pcode = 21
	IF p$ = "n" THEN pcode = 20
	IF p$ = "o" THEN pcode = 25
	IF p$ = "p" THEN pcode = 23
	IF p$ = "q" THEN pcode = 24
	IF p$ = "a" THEN pcode = 36
	IF p$ = "b" THEN pcode = 37
	IF p$ = "c" THEN pcode = 38
	IF p$ = "d" THEN pcode = 39
	IF p$ = "e" THEN pcode = 40
	IF p$ = "f" THEN pcode = 41
	IF p$ = "g" THEN pcode = 42
	RETURN

9020    bx$(0) = "r"
	bx$(1) = "R"
	bx$(2) = ""
	bx$(3) = "p"
	bx$(4) = "P"
	bx$(5) = ""
	bx$(6) = "j"
	bx$(7) = "J"
	bx$(8) = ""
	bx$(9) = "de"
	bx$(10) = "D"
	bx$(11) = ""
	bx$(12) = "t"
	bx$(13) = "T"
	bx$(14) = ""
	bx$(15) = "f"
	bx$(16) = "F"
	bx$(17) = ""
	bx$(18) = "c"
	bx$(19) = "C"
	bx$(20) = ""
	bx$(21) = "n"
	bx$(22) = "N"
	bx$(23) = ""
	bx$(24) = "sq"
	bx$(25) = "S"
	bx$(26) = ""
	bx$(27) = "wx"
	bx$(28) = "W"
	bx$(29) = ""
	bx$(30) = "g"
	bx$(31) = "G"
	bx$(32) = "Q"
	bx$(33) = "y"
	bx$(34) = "Y"
	bx$(35) = ""
	bx$(36) = "l"
	bx$(37) = "L"
	bx$(38) = ""
	bx$(39) = "uv"
	bx$(40) = "U"
	bx$(41) = ""
	bx$(42) = "h"
	bx$(43) = "H"
	bx$(44) = ""
	bx$(45) = "o"
	bx$(46) = "O"
	bx$(47) = ""
	bx$(48) = "b"
	bx$(49) = "B"
	bx$(50) = ""
	bx$(51) = "a"
	bx$(52) = "A"
	bx$(53) = ""
	bx$(54) = "z"
	bx$(55) = "Z"
	bx$(56) = ""
	bx$(57) = "m"
	bx$(58) = "M"
	bx$(59) = ""
	bx$(60) = ""
	bx$(61) = ""
	bx$(62) = ""
	bx$(63) = ""
	bx$(64) = ""
	bx$(65) = ""
	bx$(66) = "e"
	bx$(67) = ""
	bx$(68) = "e"
	bx$(69) = "d"
	bx$(70) = ""
	bx$(71) = ""
	bx$(72) = ""
	bx$(73) = ""
	bx$(74) = ""
	bx$(75) = ""
	bx$(76) = ""
	bx$(77) = ""
	bx$(78) = "{"
	bx$(79) = "}"
	bx$(80) = ""
	bx$(81) = "|"
	bx$(82) = "`"
	bx$(83) = ""
	bx$(84) = "k"
	bx$(85) = "K"
	bx$(86) = ""
	bx$(87) = "^"
	bx$(88) = "X"
	bx$(89) = ""
	bx$(90) = "["
	bx$(91) = "]"
	bx$(92) = ""
	bx$(93) = "i"
	bx$(94) = "I"
	bx$(95) = ""
	bx$(96) = ""
	bx$(97) = ""
	bx$(98) = ""
	bx$(99) = ""
	bx$(100) = ""
	bx$(101) = ""
	bx$(102) = ""
	bx$(103) = ""
	bx$(104) = ""
	bx$(105) = ""
	bx$(106) = ""
	bx$(107) = ""
	bx$(108) = "q"
	bx$(109) = ""
	bx$(110) = "q"
	bx$(111) = ""
	bx$(112) = ""
	bx$(113) = ""
	bx$(114) = "e"
	bx$(115) = ""
	bx$(116) = "e"
	bx$(117) = ""
	bx$(118) = ""
	bx$(119) = ""
	bx$(120) = "dq"
	bx$(121) = ""
	bx$(122) = "q"
	bx$(123) = "d"
	bx$(124) = ""
	bx$(125) = ""
	bx$(126) = "d"
	bx$(127) = ""
	bx$(128) = ""
	
	nx$(0) = "01r"
	nx$(1) = "01R"
	nx$(2) = "01"
	nx$(3) = "()p"
	nx$(4) = "()P"
	nx$(5) = "()"
	nx$(6) = "j"
	nx$(7) = "J"
	nx$(8) = ""
	nx$(9) = "23de"
	nx$(10) = "23D"
	nx$(11) = "23"
	nx$(12) = "45t"
	nx$(13) = "45T"
	nx$(14) = "45"
	nx$(15) = "67f"
	nx$(16) = "67F"
	nx$(17) = "67"
	nx$(18) = "89c"
	nx$(19) = "89C"
	nx$(20) = "89"

REM     nx$(21)="\"'n"
REM     nx$(22)="\"'N"
REM     nx$(23)="\"'"

	nx$(21) = CHR$(34) + "'n"
	nx$(22) = CHR$(34) + "'N"
	nx$(23) = CHR$(34) + "'"

	nx$(24) = "&sq"
	nx$(25) = "&S"
	nx$(26) = "&"
	nx$(27) = "wx"
	nx$(28) = "W"
	nx$(29) = ""
	nx$(30) = "=?g"
	nx$(31) = "=?G"
	nx$(32) = "=?Q"
	nx$(33) = "*y"
	nx$(34) = "*Y"
	nx$(35) = "*"
	nx$(36) = "l"
	nx$(37) = "L"
	nx$(38) = ""
	nx$(39) = "uv"
	nx$(40) = "U"
	nx$(41) = ""
	nx$(42) = ".+h"
	nx$(43) = ".+H"
	nx$(44) = ".+"
	nx$(45) = ",;o"
	nx$(46) = ",;O"
	nx$(47) = ",;"

REM     nx$(48)="\\b"
REM     nx$(49)="\\B"
REM     nx$(50)="\\"

	nx$(48) = "\b"
	nx$(49) = "\B"
	nx$(50) = "\"

	nx$(51) = "~a"
	nx$(52) = "~A"
	nx$(53) = "~"
	nx$(54) = "%z"
	nx$(55) = "%Z"
	nx$(56) = "%"
	nx$(57) = "Ƨm"
	nx$(58) = "ƧM"
	nx$(59) = "Ƨ"
	nx$(60) = "87"
	nx$(61) = "87"
	nx$(62) = "87"
	nx$(63) = "85"
	nx$(64) = "85"
	nx$(65) = "85"
	nx$(66) = "83e"
	nx$(67) = "83"
	nx$(68) = "83e"
	nx$(69) = "2'd"
	nx$(70) = "2'"
	nx$(71) = "2'"
	nx$(72) = "4'"
	nx$(73) = "4'"
	nx$(74) = "4'"
	nx$(75) = "8"
	nx$(76) = "8"
	nx$(77) = "8"
	nx$(78) = "{"
	nx$(79) = "}"
	nx$(80) = ""
	nx$(81) = "|"
	nx$(82) = "`"
	nx$(83) = ""
	nx$(84) = "k"
	nx$(85) = "K"
	nx$(86) = ""
	nx$(87) = "^"
	nx$(88) = "X"
	nx$(89) = ""
	nx$(90) = "["
	nx$(91) = "]"
	nx$(92) = ""
	nx$(93) = "i"
	nx$(94) = "I"
	nx$(95) = ""
	nx$(96) = ""
	nx$(97) = ""
	nx$(98) = ""
	nx$(99) = ""
	nx$(100) = ""
	nx$(101) = ""
	nx$(102) = ""
	nx$(103) = ""
	nx$(104) = ""
	nx$(105) = "ø"
	nx$(106) = ""
	nx$(107) = "í"
	nx$(108) = "4q"
	nx$(109) = "4"
	nx$(110) = "4q"
	nx$(111) = "47"
	nx$(112) = "47"
	nx$(113) = "47"
	nx$(114) = "43e"
	nx$(115) = "43"
	nx$(116) = "43e"
	nx$(117) = "8'"
	nx$(118) = "8'"
	nx$(119) = "8'"
	nx$(120) = "2dq"
	nx$(121) = "2"
	nx$(122) = "2q"
	nx$(123) = "27d"
	nx$(124) = "27"
	nx$(125) = "27"
	nx$(126) = "25d"
	nx$(127) = "25"
	nx$(128) = "25"
	
	RETURN


9090    PRINT "Chybne parametry"
	STOP

9100    END

